# Планируемая функциональность v2.0

- [x] полностью отделить ядро от ui
- [x] ES6 + асинхронные функции в движке данных
- [ ] замена dhtmlx и handsontable компонентами react
- [ ] автоматические тесты ядра и визуальных компонентов
 
### Ядро
- Использование асинхронных функций даст возможность разименования через точку не только загруженных в ОЗУ объектов данных, но так же объектов, кешируемых в doc, meta, 1С, ином внешнем хранилище или файловой системе сервера
- Получим более чистый код

### UI:Аргументы
- Сегодняшние компоненты metadata.ui предоставляют мощные возможности, схожие с поведением элементов платформы 1С, но:
  + они тянут за собой кучу зависимостей из проприетарных библиотек
  + их сложно встраивать в нестандартное приложение
  + сложно изменить их внешний вид и поведение
- Компоненты react - это UNIX-way и почти промышленный стандарт
- Получаем больше свободы в интерфейсе конечного приложения
- Получаем возможность строить изоморфные приложения или приложения с полностью серверным рендерингом
- Улучшаем быстродействие за счет виртуального DOM
  
### UI:Реализация
- Стили и базовые объекты построить на основе http://www.material-ui.com/
- Динсписок, табличный документ и табличную часть - на основе https://github.com/adazzle/react-data-grid
- Layouts - https://github.com/STRML/react-grid-layout
- Поле ввода ссылочных данных - на основе material-ui.autocomplit
- Поле ввода диапазона дат - https://github.com/Adphorus/react-date-range ??? - нормальных прототипов пока не нашел
- Поле ввода числа с калькулятором
- Компонент настроек отбора динсписка и табличной части
- PropertyGrid - редактор полей DataObj