## Модификаторы объектов и менеджеров данных
Папка `./src/modifiers` предназначена для размещения файлов, переопределяющих и дополняющих поведение объектов и менеджеров данных.
Здесь живут обработчики событий при создании и перед записью объектов, обработчики при изменении реквизитов и табличных частей, пользовательские формы объектов и списков, математика формирования отчетов.

- [common](common) - Общие модули
- [enums](enums) - Перечисления
- [catalogs](catalogs) - Справочники
- [documents](documents) - Документы
- [chartsaccounts](chartsaccounts) - Планы счетов
- [chartscharacteristics](chartscharacteristics) - Планы видов характеристик
- [dataprocessors](charts_dataprocessors) - Обработки
- [reports](reports_dataprocessors) - Отчеты
- [ireg](ireg) - Регистры сведений
- [areg](areg) - Регистры накопления
- [businessprocesses](businessprocesses) - Бизнес-процессы
- [tasks](tasks) - Задачи

Иерархия и состав папок - условные. Можно добавлять и удалять любые папки. При сборке проекта, все файлы в иерархии `./src/modifiers/**/*.js`, объединяются в общий javascript файл.
